/* nylon - (socks{4,5}) proxy
 * http://mesh.eecs.umich.edu/projects/nylon
 * marius aamodt eriksen (marius@umich.edu)
 * utility functions */

/* XXX remove unneeded */
#include <stdio.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/signal.h>
#include <netinet/in.h>
#include <errno.h>
#include "mnet.h"
#include <sys/ioctl.h>
#include <net/if.h>
#include "cfg.h"
#include "util.h"

#if defined(__sun__)
#include <sys/sockio.h>
#endif /* __sun__ */

#define IFMAX IFNAMSIZ

extern int verbose;

void fatal_error(char *msg)
{
	fprintf(stderr, "fatal error: %s\n", msg);
	if (errno)
		perror("");
	exit(1);
}

void die(char *msg)
{
	printf("%s\n", msg);
	exit(0);
}

void printd(char *msg)
{
	fprintf(stderr, "%s\n", msg);
}

struct in_addr get_ip_from_if(char *inf)
{
	struct ifreq ifr;
	struct sockaddr_in *sin;
	int bogusfd;
	char ifip[14];
	
	strlcpy(ifr.ifr_name, inf, IFMAX);
	bogusfd = socket(AF_INET, SOCK_STREAM, 0);
	ioctl(bogusfd, SIOCGIFADDR, &ifr);
	sin = (struct sockaddr_in *) &ifr.ifr_addr;
	/* display... */
	if (verbose) {
		inet_ntop(AF_INET, &sin->sin_addr, ifip, sizeof(ifip));
		printf("binding to address %s\n", ifip);
	}
	return sin->sin_addr;
}

/* copyright (c) 2001  
 * marius aamodt eriksen
 * all rights reserved
 * 
 * permission is granted to use, copy, create derivative works and
 * redistribute this software and such derivative works for any purpose,
 * so long as the name of the author is not used in any advertising or 
 * publicity pertaining to the use or distribution of this software 
 * without specific, written prior authorization.  if the above copyright 
 * notice or any other identification of the author is included in any 
 * copy of any portion of this software, then the disclaimer below must 
 * also be included.
 * 
 * this software is provided as is, without representation from the
 * the author as to its fitness for any purpose, and withoutwarranty by 
 * the author of any kind, either express or implied, including without 
 * limitation the implied warranties of merchantability and fitness for 
 * a particular purpose.  the author shall not be liable for any damages,
 * including special, indirect, incidental, or consequential damages,
 * with respect to any claim arising out or in connection with the use
 * of the software, even if it has been or is hereafter advised of the
 * possibility of such damages. */
